##### ip::basic_resolver::resolve (9 of 12 overloads)

Perform forward resolution of a query to a list of entries.

    results_type resolve(
        const protocol_type & protocol,
        string_view host,
        string_view service,
        resolver_base::flags resolve_flags);

This function is used to resolve host and service names into a list of endpoint entries.

###### Parameters

protocol

  A protocol object, normally representing either the IPv4 or IPv6 version of an internet protocol.

host

  A string identifying a location. May be a descriptive name or a numeric address string. If an empty string and the passive flag has been specified, the resolved endpoints are suitable for local service binding. If an empty string and passive is not specified, the resolved endpoints will use the loopback address.

service

  A string identifying the requested service. This may be a descriptive name or a numeric string corresponding to a port number. May be an empty string, in which case all resolved endpoints will have a port number of 0.

resolve_flags

  A set of flags that determine how name resolution should be performed. The default flags are suitable for communication with remote hosts. See the `ip::resolver_base` documentation for the set of available flags.

###### Return Value

A range object representing the list of endpoint entries. A successful call to this function is guaranteed to return a non-empty range.

###### Exceptions

asio::system_error

  Thrown on failure.

###### Remarks

On POSIX systems, host names may be locally defined in the file `/etc/hosts`. On Windows, host names may be defined in the file `c:\windows\system32\drivers\etc\hosts`. Remote host name resolution is performed using DNS. Operating systems may use additional locations when resolving host names (such as NETBIOS names on Windows).

On POSIX systems, service names are typically defined in the file `/etc/services`. On Windows, service names may be found in the file `c:\windows\system32\drivers\etc\services`. Operating systems may use additional locations when resolving service names.